import { LogLevel } from '../../models';
export declare enum SendFilterOptions {
    onlyFailed = "only-failed"
}
export type OutputType = 'body' | 'headers' | 'response' | 'none' | 'short' | 'exchange' | 'timings';
export interface SendOptions {
    env?: Array<string>;
    all?: boolean;
    bail?: boolean;
    filter?: SendFilterOptions;
    help?: boolean;
    line?: number;
    name?: string;
    interactive?: boolean;
    insecure?: boolean;
    json?: boolean;
    junit?: boolean;
    output?: OutputType;
    outputFailed?: OutputType;
    raw?: boolean;
    repeatMode?: 'sequential' | 'parallel';
    repeat?: number;
    parallel?: number;
    timeout?: number;
    silent?: boolean;
    var?: Array<string>;
    verbose?: boolean;
}
export declare function getLogLevel(cliOptions: SendOptions): LogLevel | undefined;
