import { AMQPChannel, AMQPClient } from '@cloudamqp/amqp-client';
import * as models from '../../models';
export declare class AmqpRequestClient extends models.AbstractRequestClient<AMQPClient | undefined> {
    private readonly request;
    private readonly context;
    constructor(request: models.Request, context: models.ProcessorContext);
    get reportMessage(): string;
    get supportsStreaming(): boolean;
    getSessionId(): string;
    private _channel;
    get channel(): AMQPChannel | undefined;
    private _nativeClient;
    get nativeClient(): AMQPClient | undefined;
    connect(obj: AMQPClient | undefined): Promise<AMQPClient | undefined>;
    send(body?: unknown): Promise<void>;
    private executeAmqpMethod;
    disconnect(err?: Error): void;
    private getMethod;
}
