import { ProcessorContext, Request } from '../../models';
export type GqlLoadData = string | ((context: ProcessorContext) => Promise<string | undefined>);
export interface GqlData {
    operationName?: string;
    query?: GqlLoadData;
    fragments: Record<string, GqlLoadData>;
}
export interface GqlPostRequest {
    query: string;
    operationName?: string;
    variables?: Record<string, unknown>;
}
export declare class GqlAction {
    private readonly gqlData;
    id: string;
    before: string[];
    constructor(gqlData: GqlData);
    process(request: Request, context: ProcessorContext): Promise<void>;
}
