import * as grpc from '@grpc/grpc-js';
import { ProtoDefinition } from '../../models';
export interface ServiceData {
    server: string;
    path: string;
    service: string;
    method: string;
    protocol: string;
    ServiceClass: {
        new (address: string, credentials: grpc.ChannelCredentials, options?: Partial<grpc.ChannelOptions>): GrpcClient;
    };
    methodDefinition: grpc.MethodDefinition<unknown, unknown>;
}
export interface GrpcClient extends grpc.Client {
    close(): void;
    [key: string]: Function;
}
export declare const GrpcUrlRegex: RegExp;
export declare function getSerivceData(url: string, protoDefinitions: Record<string, ProtoDefinition>): ServiceData;
