import * as models from '../../models';
import { GrpcClient } from './createGrpcService';
export declare class GrpcRequestClient extends models.AbstractRequestClient<GrpcClient | undefined> {
    private readonly request;
    private readonly context;
    private grpcStream;
    private responseTemplate;
    constructor(request: models.Request, context: models.ProtoProcessorContext);
    get reportMessage(): string;
    get supportsStreaming(): boolean;
    private _clientDefinition;
    private _nativeClient;
    get nativeClient(): GrpcClient | undefined;
    private getChannelOptions;
    getSessionId(): string;
    connect(prevClient: GrpcClient | undefined): Promise<GrpcClient | undefined>;
    send(body?: unknown): Promise<void>;
    private callMethod;
    private getMethodArgs;
    private getData;
    streamEnded(): void;
    disconnect(err?: Error): void;
    private registerEvents;
    private getMetaData;
    private toHttpResponse;
    private isGrpcError;
}
