/// <reference types="node" />
/// <reference types="node" />
/// <reference types="node/http" />
/// <reference types="got/dist/source/core/utils/timed-out" />
import { OptionsOfUnknownResponseBody, Response } from 'got';
import * as models from '../../models';
export declare function gotHttpClient(request: models.HttpClientRequest, context: models.HttpClientContext): Promise<models.HttpResponse | false>;
export declare function getClientOptions(request: models.HttpRequest, context: models.HttpClientContext): OptionsOfUnknownResponseBody;
export declare function toHttpResponse(response: Response<unknown>, request: models.Request): {
    name: string;
    statusCode: number;
    protocol: string;
    statusMessage: string | undefined;
    body: unknown;
    rawHeaders: string[];
    rawBody: Buffer;
    headers: import("http").IncomingHttpHeaders;
    timings: {
        wait?: number | undefined;
        dns?: number | undefined;
        tcp?: number | undefined;
        tls?: number | undefined;
        request?: number | undefined;
        firstByte?: number | undefined;
        download?: number | undefined;
        total?: number | undefined;
    };
    httpVersion: string;
    request: {
        protocol: string;
        method: import("got").Method;
        url: string;
        headers: import("got").Headers;
        body: string | Buffer | undefined;
    };
    contentType: models.ContentType | undefined;
    meta: {
        ip: string | undefined;
        redirectUrls: string[];
        size: string;
    };
};
export declare function getBody(body: unknown): string | Buffer | undefined;
