import WebSocket from 'ws';
import * as models from '../../models';
export declare class WebsocketRequestClient extends models.AbstractRequestClient<WebSocket | undefined> {
    private readonly request;
    private readonly context;
    private _nativeClient;
    private responseTemplate;
    constructor(request: models.Request, context: models.ProcessorContext);
    get reportMessage(): string;
    get supportsStreaming(): boolean;
    get nativeClient(): WebSocket | undefined;
    getSessionId(): string;
    connect(obj: WebSocket | undefined): Promise<WebSocket | undefined>;
    send(body?: unknown): Promise<void>;
    disconnect(err?: Error): void;
    private closeWebsocket;
    private registerEvents;
    private getClientOptions;
    private initProxy;
}
